//+---------------------------------------------------------------------------+
//|                                                         mv-i-Fibo_1_0.mq4 |
//|                                                  . MaxV42 |
//|                                                http://                    |
//|   -     .  |
//+---------------------------------------------------------------------------+
//|  1.0  22.03.2010                                                  |
//+---------------------------------------------------------------------------+
#property copyright "  . MaxV42"
#property link      "http://"
//+---------------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width3 1
#property indicator_width4 1
//+---------------------------------------------------------------------------+
extern string Ind_Coment1= "---    ---";
extern int   TF.Upper                  =  1440;    //  
extern bool  ShowFractals.UpperTF      = false;    // /  
extern bool  Show.FiboLevels           =  true;    // / -
extern bool  Show.FiboArcs             =  true;    // / -
extern int   nFibo                     =     1;    // - -
//+---------------------------------------------------------------------------+
extern string Ind_Coment2= "---    ---";
extern color Fibo.Color0           =     DodgerBlue;  //  0 -
extern color Fibo.Color1           =        Magenta;  //  1 -
extern color Fibo.Color2           =          Green;  //  2 -
extern color Fibo.Color3           =           Peru;  //  3 -
extern color Fibo.Color4           =          Black;  //   -
extern int   nBars.History             =       1000;  // -   
//+---------------------------------------------------------------------------+
//  
int          nBars.LowerTF             =     0,    // -   
             nBars.UpperTF             =     0;    // -   
int          QntFiboLevels             =     0;    // -   -

//----- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+---------------------------------------------------------------------------+
void init()  {        // Custom indicator initialization function

  // ----- Indicators Properties
  SetIndexStyle(0,DRAW_ARROW);
  SetIndexArrow(0,119);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexEmptyValue(0,0.0);
  SetIndexStyle(1,DRAW_ARROW);
  SetIndexArrow(1,119);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexEmptyValue(1,0.0);

  // ----- Name for DataWindow and indicator subwindow label
  IndicatorShortName("mv-i-Fibo_1_0");
  SetIndexLabel(0,"FractalsUp.UpperTF");
  SetIndexLabel(1,"FractalsDown.UpperTF");

  return;
}

//+---------------------------------------------------------------------------+
void deinit()   {     // Custom indicator deinitialization function
  // -----  -  
  DeleteFibo();
 return;
}

//+---------------------------------------------------------------------------+
void start() {        // Custom indicator iteration function
int    counted_bars=IndicatorCounted();
int    limit;
int    Spred=MarketInfo(Symbol(),MODE_SPREAD);
double Fractals.Upper=0,Fractals.Lower=0;
  // -----    
  if(!CheckParameters()) return;
  // -----    
  if(!isNewBar.LowerTF()) return;
  // -----     
  if (counted_bars>0) counted_bars--;
  limit=Bars-counted_bars; if(limit>nBars.History) limit=nBars.History;
  // -----  
  for (int i=limit; i>=0; i--)   {
    //--------------------------------------------------------- 1 --
    // -----     
    if(isNewBar.UpperTF(Time[i]))  {
      Fractals.Upper=0;Fractals.Lower=0;
      Fractals.Upper=iFractals(NULL,TF.Upper,MODE_UPPER,nBars.UpperTF);
      Fractals.Lower=iFractals(NULL,TF.Upper,MODE_LOWER,nBars.UpperTF);
      // -----     
      if(Fractals.Upper>0)  {
        // -----    
        if(ShowFractals.UpperTF)  {
          ExtMapBuffer1[iBarShift(NULL,0,iTime(NULL,TF.Upper,nBars.UpperTF),false)]=Fractals.Upper+Spred*Point;
        }
        // -----  -
        DrawFibo(nBars.UpperTF);
      }
      // -----     
      if(Fractals.Lower>0)  {
        // -----    
        if(ShowFractals.UpperTF)  {
          ExtMapBuffer2[iBarShift(NULL,0,iTime(NULL,TF.Upper,nBars.UpperTF),false)]=Fractals.Lower-Spred*Point;
        }
        // -----  -
        DrawFibo(nBars.UpperTF);
      }
    }

  }

  return;
}

//+---------------------------------------------------------------------------+
bool isNewBar.LowerTF() {  //   true,       
  if(nBars.LowerTF!=Bars) {
    nBars.LowerTF=Bars; return(true);
  }
  return(false);
}

//+---------------------------------------------------------------------------+
bool isNewBar.UpperTF(datetime DateTime_) {  //   true,       
  if(nBars.UpperTF!=iBarShift(NULL, TF.Upper, DateTime_, false)) {
    nBars.UpperTF=iBarShift(NULL, TF.Upper, DateTime_, false); return(true);
  }
  return(false);
}

//+---------------------------------------------------------------------------+
bool CheckParameters()  {     //     
string TextMessage;

  if(TF.Upper<=Period())  {
    TextMessage="    !"+
                        "     >() !";
    Alert(TextMessage);
    return(false);
  }

  return(true);
}




//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+--------------------------------------------   - ---------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+

//+---------------------------------------------------------------------------+
color GetFiboColor(int Index) {  //    -  
  switch(Index) {
    case 0:
      return(Fibo.Color0);
    case 1:
      return(Fibo.Color1);
    case 2:
      return(Fibo.Color2);
    case 3:
      return(Fibo.Color3);
  }
  return(Fibo.Color4);
}

//+---------------------------------------------------------------------------+
void DeleteFibo()  {             //    -  
int    Qnt=ObjectsTotal();
  for (int i=0; i<Qnt; i++)   {  //   
    if(StringFind(ObjectName(i),"FiboLevels",0)>=0) {
      ObjectDelete(ObjectName(i));      // -
      i--; continue;
    }
    if(StringFind(ObjectName(i),"FiboArcs",0)>=0) {
      ObjectDelete(ObjectName(i));     //  -
      i--; continue;
    }
    if(i>=ObjectsTotal()) break;
  }
 return;
}

//+---------------------------------------------------------------------------+
void DrawFibo(int nBar)  {            //   -  
double Fractals.Upper=0,Fractals.Lower=0;
string mFractals[][3];
int i,j=0;
  ArrayResize(mFractals,nFibo*4);
  // -----  -  
  DeleteFibo();
  //--------------------------------------------------------- 1 --
  // -----   
  for (i=nBar; i<Bars; i++)   {  //   
    Fractals.Upper=iFractals(NULL,TF.Upper,MODE_UPPER,i);
    Fractals.Lower=iFractals(NULL,TF.Upper,MODE_LOWER,i);
    if(Fractals.Lower>0)  {
      mFractals[j][0]=TimeToStr(iTime(NULL,TF.Upper,i),TIME_DATE|TIME_MINUTES);
      mFractals[j][1]=DoubleToStr(Fractals.Lower,Digits);
      mFractals[j][2]=-1;
      j++;
    }
    if(Fractals.Upper>0)  {
      mFractals[j][0]=TimeToStr(iTime(NULL,TF.Upper,i),TIME_DATE|TIME_MINUTES);
      mFractals[j][1]=DoubleToStr(Fractals.Upper,Digits);
      mFractals[j][2]=1;
      j++;
    }
    if(j>(nFibo*4-1)) break;
  }
  //--------------------------------------------------------- 2 --
  j=0;
  for (i=0; i<nFibo*4-1; i++)   {
    // -----     ,  
    if(StrToDouble(mFractals[i][2])==StrToDouble(mFractals[i+1][2])) continue;
    // -----  -
    if(Show.FiboLevels)  {
      ObjectCreate("FiboLevels"+j,OBJ_FIBO,0,StrToTime(mFractals[i][0]),StrToDouble(mFractals[i][1]),StrToTime(mFractals[i+1][0]),StrToDouble(mFractals[i+1][1]));
      ObjectSet("FiboLevels"+j,OBJPROP_FIBOLEVELS,12); // -38.2; -23.6; -14.5; 0; 14.5; 23.6; 38.2; 50; 61.8; 100; 161.8; 261.8;
      ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+0,-0.382); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+1,-0.236); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+2,-0.145);
      ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+3,0); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+4,0.145); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+5,0.236);
      ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+6,0.382); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+7,0.50); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+8,0.618);
      ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+9,1.00); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+10,1.618); ObjectSet("FiboLevels"+j,OBJPROP_FIRSTLEVEL+11,2.618);
      ObjectSetFiboDescription("FiboLevels"+j,0,"-38.2"); ObjectSetFiboDescription("FiboLevels"+j,1,"-23.6"); ObjectSetFiboDescription("FiboLevels"+j,2,"-14.5");
      ObjectSetFiboDescription("FiboLevels"+j,3,"0"); ObjectSetFiboDescription("FiboLevels"+j,4,"14.5"); ObjectSetFiboDescription("FiboLevels"+j,5,"23.6");
      ObjectSetFiboDescription("FiboLevels"+j,6,"38.2"); ObjectSetFiboDescription("FiboLevels"+j,7,"50"); ObjectSetFiboDescription("FiboLevels"+j,8,"61.8");
      ObjectSetFiboDescription("FiboLevels"+j,9,"100"); ObjectSetFiboDescription("FiboLevels"+j,10,"161.8"); ObjectSetFiboDescription("FiboLevels"+j,11,"261.8");
      ObjectSet("FiboLevels"+j,OBJPROP_COLOR,GetFiboColor(j)); ObjectSet("FiboLevels"+j,OBJPROP_LEVELCOLOR,GetFiboColor(j));
    }
    // -----  -
    if(Show.FiboArcs)  {
      ObjectCreate("FiboArcs"+j,OBJ_FIBOARC,0,StrToTime(mFractals[i][0]),StrToDouble(mFractals[i][1]),StrToTime(mFractals[i][0]),StrToDouble(mFractals[i+1][1]));
      ObjectSet("FiboArcs"+j,OBJPROP_FIBOLEVELS,6); // 38.2; 50; 61.8; 100; 114.5; 138.2;
      ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+0,0.382); ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+1,0.50); ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+2,0.618);
      ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+3,1.00); ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+4,1.145); ObjectSet("FiboArcs"+j,OBJPROP_FIRSTLEVEL+5,1.382);
      ObjectSetFiboDescription("FiboArcs"+j,0,"38.2"); ObjectSetFiboDescription("FiboArcs"+j,1,"50"); ObjectSetFiboDescription("FiboArcs"+j,2,"61.8");
      ObjectSetFiboDescription("FiboArcs"+j,3,"100"); ObjectSetFiboDescription("FiboArcs"+j,4,"114.5"); ObjectSetFiboDescription("FiboArcs"+j,5,"138.2");
      ObjectSet("FiboArcs"+j,OBJPROP_COLOR,GetFiboColor(j)); ObjectSet("FiboArcs"+j,OBJPROP_LEVELCOLOR,GetFiboColor(j));
      ObjectSet("FiboArcs"+j,OBJPROP_LEVELSTYLE,STYLE_DASH);
    }
    j++;
    if(j>(nFibo-1)) break;
  }
  
}


